#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.indexing.constructs.idelayed import IDelayed
from bu4.indexing.constructs.indexed import Indexed
from bu4.parsing.codes import CODE_DLYD
from bu4.parsing.extensions.extension import Extension
from bu4.parsing.states.parsingread import ParsingRead
from bu4.transform.states.aftertransform import AfterTransform
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState
from bu4.transform.targets.atlambda import ATLambda

__all__ = ('XIDlyd',)


class XIDlyd(Extension[Indexed], code=CODE_DLYD):
    def apply(self) -> TransformState[Indexed]:
        return AfterTransform(
            ParsingRead(self.parser),
            ATLambda(
                lambda value: TransformFinished(IDelayed(value))
            )
        )
