#  Copyright (c) PARRRATE T&V 2021. All rights reserved.

from bu4.indexing.constructs.ilambda import ILambda
from bu4.indexing.constructs.indexed import Indexed
from bu4.parsing.codes import CODE_MAKE
from bu4.parsing.extensions.extension import Extension
from bu4.parsing.states.parsingread import ParsingRead
from bu4.transform.states.aftertransform import AfterTransform
from bu4.transform.states.transformfinished import TransformFinished
from bu4.transform.states.transformstate import TransformState
from bu4.transform.targets.atlambda import ATLambda

__all__ = ('XIMake',)


class XIMake(Extension[Indexed], code=CODE_MAKE):
    def apply(self) -> TransformState[Indexed]:
        memoize = bool(self.parser.read())
        table = [self.parser.read() for _ in range(self.parser.read())]
        return AfterTransform(
            ParsingRead(self.parser),
            ATLambda(
                lambda value: TransformFinished(ILambda(value, table, memoize=memoize))
            )
        )
